
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

Unit Sound;

Interface
uses xms;
var current:record
                handle:word;
                offset,size:longint;
                priority:byte;
                playing:boolean;
                freq:word;
              end;
function init_sound:boolean;
procedure close_sound;
procedure play_wav(Xfic:fileXMS;prior:byte);
procedure dmastop;
procedure Playback(sound : Pointer; size : word; frequency : word);

Implementation
uses dos,crt;
const buffsize=65528;
var      DSP_RESET : word;
     DSP_READ_DATA : word;
    DSP_WRITE_DATA : word;
  DSP_WRITE_STATUS : word;
    DSP_DATA_AVAIL : word;
    old_irq:pointer;
    irqmsk:byte;

    blaster:record port:word; dma,irq:byte; end;
    sons_pg:pointer;

procedure WriteDSP(value : byte);
begin
  while Port[DSP_WRITE_STATUS] And $80 <> 0 do;
  Port[DSP_WRITE_DATA] := value;
end;

procedure DMAContinue;
begin
  WriteDSP($D4);
end;

procedure DMAStop;
begin
  WriteDSP($D0);
end;

procedure Playback(sound : Pointer; size : word; frequency : word);
var time_constant : word;
     page, offset : word;
begin
  Port[DSP_RESET] := 1;
  Port[DSP_RESET] := 0;

  size := size - 1;

  { Set the playback frequency }
  time_constant := 256 - 1000000 div frequency;
  WriteDSP($40);
  WriteDSP(time_constant);

  { Set up the DMA chip }
  offset := Seg(sound^) Shl 4 + Ofs(sound^);
  page := (Seg(sound^) + Ofs(sound^) shr 4) shr 12;
  Port[$0A] := blaster.dma+4;
  Port[$0C] := 0;
  Port[$0B] := $48+blaster.dma;
  Port[$02] := Lo(offset);
  Port[$02] := Hi(offset);
  Port[$03] := Lo(size);
  Port[$03] := Hi(size);
  Port[$83] := page;
  Port[$0A] := blaster.dma;

  { Set the playback type (8-bit) }
  WriteDSP($14);
  WriteDSP(Lo(size));
  WriteDSP(Hi(size));
end;

procedure play_wav(Xfic:fileXMS;prior:byte);
var data:longint;
begin
  if (sons_pg=nil) or current.playing and (prior<=current.priority) then exit;
  with current do begin
    priority:=prior;
    playing:=true;
    handle:=Xfic.handle;
    offset:=Xfic.offset;
    inc(offset,8);
    moveXMS(handle,offset,0,seg(data)*$10000+ofs(data),4);
    if data<>$45564157 then exit;
    inc(offset,4);
    moveXMS(handle,offset,0,seg(data)*$10000+ofs(data),4);
    inc(offset,4);

    while data<>$20746d66 do begin
      moveXMS(handle,offset,0,seg(data)*$10000+ofs(data),4);
      inc(offset,4+data);
      moveXMS(handle,offset,0,seg(data)*$10000+ofs(data),4);
      inc(offset,4);
    end;

    moveXMS(handle,offset,0,seg(data)*$10000+ofs(data),4);
    inc(offset,8);
    moveXMS(handle,offset,0,seg(freq)*$10000+ofs(freq),2);
    inc(offset,data-4);
    moveXMS(handle,offset,0,seg(data)*$10000+ofs(data),4);
    inc(offset,4);
    while data<>$61746164 do begin
      moveXMS(handle,offset,0,seg(data)*$10000+ofs(data),4);
      inc(offset,4+data);
      moveXMS(handle,offset,0,seg(data)*$10000+ofs(data),4);
      inc(offset,4);
    end;
    moveXMS(handle,offset,0,seg(current.size)*$10000+ofs(current.size),4);
    inc(offset,4);
    moveXMS(handle,offset,0,seg(sons_pg^)*$10000+ofs(sons_pg^),buffsize);
    inc(offset,buffsize);
    if size>buffsize then playback(sons_pg,buffsize,freq)
    else playback(sons_pg,size,freq);
    moveXMS(handle,offset,0,seg(sons_pg^)*$10000+ofs(sons_pg^),buffsize);
    dec(size,buffsize);
    inc(offset,buffsize);
  end;
end;

procedure new_irq; interrupt;
begin
  with current do begin
    if size>0 then begin
      if size>buffsize then playback(sons_pg,buffsize,freq)
      else playback(sons_pg,size,freq);
      moveXMS(handle,offset,0,seg(sons_pg^)*$10000+ofs(sons_pg^),buffsize);
      dec(size,buffsize);
      inc(offset,buffsize);
    end else playing:=false;
  end;
  Port[$20] := $20;
end;

function init_sound:boolean;
var env_str:string;
    b:byte;
begin
  init_sound:=false;
  Blaster.port:=0;
  Blaster.dma:=0;
  Blaster.irq:=0;
  env_str:=GetEnv('BLASTER');
  If env_str='' then exit;
  b:=1;
  Repeat
    Case env_str[b] of
      'A' : Repeat
              Inc(b);
              Blaster.Port:=Blaster.Port*16+Ord(env_str[b])-48;
            Until env_str[b+1]=' ';
      'D' : Begin
              Blaster.DMA:=Ord(env_str[b+1])-48;
              Inc(b,2);
            End;
      'I' : Repeat
              Inc(b);
              Blaster.IRQ:=Blaster.IRQ*16+Ord(env_str[b])-48;
            Until env_str[b+1]=' ';
        End;
    Inc(b);
  Until b>Length(env_str);

  { Calculate the port addresses }
  DSP_RESET := blaster.port + $6;
  DSP_READ_DATA := blaster.port + $A;
  DSP_WRITE_DATA := blaster.port + $C;
  DSP_WRITE_STATUS := blaster.port + $C;
  DSP_DATA_AVAIL := blaster.port+ $E;

  { Reset the DSP, and give some nice long delays just to be safe }
  Port[DSP_RESET] := 1;
  Delay(10);
  Port[DSP_RESET] := 0;
  Delay(10);
  if (Port[DSP_DATA_AVAIL] And $80 = $80) And
     (Port[DSP_READ_DATA] = $AA) then begin
    getintvec($8+blaster.irq,old_irq);          { sauvegarder ancienne interruption   }
    setintvec($8+blaster.irq,@new_irq);   { positionner sur sa propre routine  }
    irqmsk := 1 shl blaster.irq;               { masquer interruption     }
    Port[$20] := $20;
    port[$21] := port[$21] and not irqmsk;
    getmem(sons_pg,buffsize);
{ SpeakerOn connects the DAC to the speaker }
    WriteDSP($D1);
    init_sound:=true;
  end;
end;

procedure close_sound;
begin
  if sons_pg<>nil then begin
    freemem(sons_pg,buffsize);
    setintvec($8+blaster.irq,old_irq);         { Rtablir l'ancienne interruption}
    port[$21] := Port[$21] or irqmsk;     { et ramne la masque }
    Port[$20] := $20;
  end;
  sons_pg:=nil;
end;

end.
